/* Common hooks for ATMEL AVR.
   Copyright (C) 1998, 1999, 2000, 2001, 2002, 2004, 2005, 2006, 2007, 2008,
   2009, 2010, 2011 Free Software Foundation, Inc.

   This file is part of GCC.

   GCC is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.
   
   GCC is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with GCC; see the file COPYING3.  If not see
   <http://www.gnu.org/licenses/>.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "common/common-target.h"
#include "common/common-target-def.h"

/* Implement TARGET_OPTION_OPTIMIZATION_TABLE.  */
static const struct default_options avr_option_optimization_table[] =
  {
    { OPT_LEVELS_1_PLUS, OPT_fomit_frame_pointer, NULL, 1 },
    { OPT_LEVELS_NONE, 0, NULL, 0 }
  };

static bool
avr_handle_target_option (struct gcc_options *opts,
        struct gcc_options *opts_set, const struct cl_decoded_option *decoded,
        location_t loc)
{
  if (avr_list_supported_parts)
    {
      const struct mcu_type_s *list_part;

      fprintf (stdout, "List of parts supported by avr-gcc:\n");

      for (list_part = &avr_mcu_types[0]; list_part->name; list_part++)
        {
          if (!list_part->macro)
            list_part++;
          fprintf (stdout, "%-20s%s\n", list_part->name, list_part->macro);
        }

      fprintf (stdout, "\n");

    }

  return true;
}


#undef TARGET_OPTION_OPTIMIZATION_TABLE
#define TARGET_OPTION_OPTIMIZATION_TABLE avr_option_optimization_table

#undef TARGET_EXCEPT_UNWIND_INFO
#define TARGET_EXCEPT_UNWIND_INFO sjlj_except_unwind_info

#undef TARGET_HANDLE_OPTION
#define TARGET_HANDLE_OPTION avr_handle_target_option

struct gcc_targetm_common targetm_common = TARGETM_COMMON_INITIALIZER;
